function secondsToStr (seconds) {
	return millisecondsToStr(seconds*1000);
}

// http://stackoverflow.com/a/8212878
function millisecondsToStr (milliseconds) {
	// TIP: to find current time in milliseconds, use:
	// var  current_time_milliseconds = new Date().getTime();

	function numberEnding (number) {
		return (number > 1) ? 's' : '';
	}

	var temp = Math.floor(milliseconds / 1000);
	var years = Math.floor(temp / 31536000);
	if (years) {
		return years + ' year' + numberEnding(years);
	}
	//TODO: Months! Maybe weeks? 
	var days = Math.floor((temp %= 31536000) / 86400);
	if (days) {
		return days + ' day' + numberEnding(days);
	}
	var hours = Math.floor((temp %= 86400) / 3600);
	if (hours) {
		return hours + ' hour' + numberEnding(hours);
	}
	var minutes = Math.floor((temp %= 3600) / 60);
	if (minutes) {
		return minutes + ' minute' + numberEnding(minutes);
	}
	var seconds = temp % 60;
	if (seconds) {
		return seconds + ' second' + numberEnding(seconds);
	}
	return 'less than a second'; //'just now' //or other string you like;
}

function Eta (count) {
	this.count = count;
}

Eta.prototype.start = function () {
	this.done = 0;
	this.startedAt = new Date();
};

Eta.prototype.iterate = function () {
	this.done++;
};

Eta.prototype.getLengthInSeconds = function () {
	var now = new Date();
	return (now.getTime() - this.startedAt.getTime())/1000;
};

Eta.prototype.getEstimatedLengthInSeconds = function () {
	return this.getIterationsPerSecond()*this.count;
};

Eta.prototype.getIterationsPerSecond = function () {
	return this.getLengthInSeconds()/this.done;
};

Eta.prototype.getPercentage = function () {
	return (100*this.done/this.count).toFixed(1) + '%';
};

Eta.prototype.getEtaInSeconds = function () {
	return this.getEstimatedLengthInSeconds() - this.getLengthInSeconds();
};

Eta.prototype.getEtaFormatted = function () {
	return secondsToStr(this.getEtaInSeconds());
};

module.exports = Eta;
